{-
A de-sugared variation on Dfa1.hs:
 - no pattern matching; observers are used
 - pairs and lists are used, but not maybes
This version is not suited for simple partial evaluation.
The trouble is the look-up of a new state.
That look-up is dynamic and so the subsequent run is. 
-}

module Dfa2 where

import Prelude hiding (elem, lookup)
import Dfa1 (State, Label, Accept, Transitions, accept, transitions)


-- Run the input on a DFA and report acceptance

run :: State -> Accept -> Transitions -> [Label] -> Bool
run s accept transitions ls =
  if null ls
  then s `elem` accept
  else let x = lookup s transitions in
       let y = lookup' (head ls) x in
       if (null y)
       then False
       else run (head y) accept transitions (tail ls)

-- Member-ship test

x `elem` xs
 = if null xs
     then False
     else if x == head xs then True else x `elem` tail xs


-- Partial and total look-up functions

lookup x xys
 = if x == fst (head xys)
     then snd (head xys)
     else lookup x (tail xys)

lookup' x xys
 = if null xys
     then []
     else if x == fst (head xys)
            then [snd (head xys)] 
            else lookup' x (tail xys)


-- Testing

main
 = do
      print $ run 1 accept transitions ['a']
      print $ run 1 accept transitions ['b']
      print $ run 1 accept transitions ['a', 'b']
      print $ run 1 accept transitions ['a', 'b', 'a']
