{- 

A variation on Dfa1.hs better suited for partial evaluation.  The
search for a target state is combined with the actual processing of
the state.

-}

import Prelude hiding (elem, lookup)
import Dfa1 (State, Label, Accept, Transitions, accept, transitions)
import Dfa2 (elem, lookup)


-- Run the input on a DFA and report acceptance

-- BEGIN_FINAL_DFA
run :: State -> Accept -> Transitions -> [Label] -> Bool
run s accept transitions ls =
  if null ls
  then s `elem` accept
  else runNext (lookup s transitions) accept transitions ls

runNext s accept transitions ls =
  if null s 
  then False
  else if (head ls) == fst (head s)
          then run (snd (head s)) accept transitions (tail ls)
          else runNext (tail s) accept transitions ls
-- END_FINAL_DFA

-- Testing

main
 = do
      print $ run 1 accept transitions ['a']
      print $ run 1 accept transitions ['b']
      print $ run 1 accept transitions ['a', 'b']
      print $ run 1 accept transitions ['a', 'b', 'a']
