 {-

A VERY simple partial evaluator
that essentially online inlines,
but it does not build a proper residual program.

-}

module SimplePEval where

import Data.Maybe
import Prelude hiding (exp)
import Eval (Prog, FDef, Expr(..), Val(..), Op(..), prim, exp, expProg, elemProg, lookupProg, runProg, runProg')

-- Partial evaluator

isVal :: Expr -> Bool
isVal (Const _) = True
isVal _ = False

-- Environment
-- BEGIN_NEWENV
type Env = [(String, Expr)]
-- END_NEWENV

-- BEGIN_SIMPLE_PEVAL
peval :: Prog -> Expr
peval (fdefs, main) = peval' main []

 where

  peval' :: Expr -> Env -> Expr

  peval' (Const v) env = Const v

  peval' (Var s) env =
    case lookup s env of
      Just e  -> e
      Nothing -> Var s -- return code for variable

  peval' (Prim op es) env =
   let rs = [ peval' e env | e <- es ] in
    if all isVal rs
     then Const (prim op (map getVal rs))
     else Prim op rs -- return code for primitive

  peval' (If e0 e1 e2) env =
   let r0 = peval' e0 env in
    if isVal r0 
     then if getBool (getVal r0) 
           then peval' e1 env
           else peval' e2 env
     else (If r0 
                (peval' e1 env) 
                (peval' e2 env)) -- return code for if

  peval' (Apply f es) env =
   peval' body env'
   where
    (ss, body) = fromJust (lookup f fdefs)
    env' = zip ss [ peval' e env | e <- es ]  
-- END_SIMPLE_PEVAL

  peval' (Let s e1 e2) env =
   if isVal r1
   then peval' e2 ((s, r1):env) 
   else Let s r1 (peval' e2 env)
   where 
    r1 = peval' e1 env

-- Testing

expProg' = ([exp], Apply "exp" [Var "x", Const (IVal 3)])
expProg'' = ([exp], Apply "exp" [Const (IVal 2), Var "n"])

printBind (name, (args, body)) = do 
    putStr "  " 
    putStr name
    print args
    putStr "    "
    print $ body
    
test (env,exp) = do
  putStr "\n> "
  print $ exp
  sequence [ printBind bnd | bnd <- env ]
  putStr "* "
  print $ peval (env, exp)
  
main
 = do 
      test expProg
      test expProg'
      -- test expProg'' -- diverges
      test elemProg
      test lookupProg
      test (runProg (Const (List [Char 'a'])))
      test (runProg (Const (List [Char 'b'])))
      test (runProg (Const (List [Char 'a', Char 'b'])))
      test (runProg (Const (List [Char 'a', Char 'b', Char 'a'])))
      test (runProg' (Const (List [Char 'a'])))
      test (runProg' (Const (List [Char 'b'])))
      test (runProg' (Const (List [Char 'a', Char 'b'])))
      test (runProg' (Const (List [Char 'a', Char 'b', Char 'a'])))
